﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.JavaScript.Shared.Serializer;

namespace TreeGridSample
{
    public partial class TreeGridDefault : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            var DataSource = this.GetDataSource();
            this.Treegrid.DataSource = DataSource;
            this.Treegrid.DataBind();

        }
        public class Resource
        {
            public int id { get; set; }
            public string text { get; set; }
            public string value { get; set; }
        }
        public class ResourceDetails
        {
            public List<Resource> GetStageCollection()
            {
                List<Resource> stageCollection = new List<Resource>();

                stageCollection.Add(new Resource() { id = 1, text = "Project Manager", value = "Project Manager" });
                stageCollection.Add(new Resource() { id = 2, text = "Software Analyst", value = "Software Analyst" });
                stageCollection.Add(new Resource() { id = 3, text = "Developer", value = "Developer" });
                stageCollection.Add(new Resource() { id = 4, text = "Testing Engineer", value = "Testing Engineer" });
                return stageCollection;
            }
        }
        #region Create DataSource for Default Gantt control

        private List<BusinessObject> GetDataSource()
        {
            List<BusinessObject> list = new List<BusinessObject>();

            list.Add(new BusinessObject()
            {
                Id = 1,
                Name = "Project Schedule",
                StartDate = "08:00:00 AM",
                EndDate = "10:00:00 PM",
                PercentDone = "40",
                Resource = "Project Manager",
                Children = (new List<BusinessObject>()
                    {
                        new BusinessObject()
                        {
                            Id = 2,
                            Name = "Planning",
                            StartDate = "08:00:00 AM",
                            EndDate="10:00:00 PM",
                            PercentDone = "40",
                            Resource="Project Manager",
                            Children=(new List<BusinessObject>()
                            {
                                new BusinessObject()
                                {
                                    Id = 3,
                                    Name = "Plan timeline",
                                    StartDate = "08:00:00 AM",
                                    EndDate="10:00:00 PM",
                                    PercentDone = "40"                            
                                },
                                new BusinessObject()
                                {
                                    Id = 4,
                                    Name = "Plan Budget",
                                    StartDate = "08:00:00 AM",
                                    EndDate="10:00:00 PM",
                                    PercentDone = "40",   
                                    Resource="Project Manager",
                                },
                                new BusinessObject()
                                {
                                    Id = 5,
                                    Name = "Allocate resources",
                                    StartDate = "08:00:00 AM",
                                    EndDate="10:00:00 PM",
                                    PercentDone = "40", 
                                    Resource="Project Manager",
                                },
                                new BusinessObject()
                                {
                                    Id = 6,
                                    Name = "Planning complete",
                                    StartDate = "08:00:00 AM",
                                    EndDate="10:00:00 PM",
                                    PercentDone = "40"                            
                                },
                            })
                        }, 
                        new BusinessObject()
                        {
                            Id = 7,
                            Name = "Design",
                            StartDate = "08:00:00 AM",
                            EndDate="10:00:00 PM",
                            PercentDone = "40",
                            Children=(new List<BusinessObject>()
                            {
                                new BusinessObject()
                                {
                                    Id = 8,
                                    Name = "Software Specification",
                                    StartDate = "08:00:00 AM",
                                    EndDate="10:00:00 PM",
                                    PercentDone = "40", 
                                    Resource="Project Manager",
                                },
                                new BusinessObject()
                                {
                                    Id = 9,
                                    Name = "Develop prototype",
                                    StartDate = "08:00:00 AM",
                                    EndDate="10:00:00 PM",
                                    PercentDone = "40"                            
                                },
                                new BusinessObject()
                                {
                                    Id = 10,
                                    Name = "Get approval from customer",
                                    StartDate = "08:00:00 AM",
                                    EndDate="10:00:00 PM",
                                    PercentDone = "40" ,
                                    Resource="Project Manager",
                                },
                                new BusinessObject()
                                {
                                    Id = 11,
                                    Name = "Design complete",
                                    StartDate = "08:00:00 AM",
                                    EndDate="10:00:00 PM",
                                    PercentDone = "40"                            
                                },
                            })
                        }                      
                    }),
        });
             return list;
        }
           
        
        #endregion

        #region BusinessObject Creation
        public class BusinessObject
        {
            public string StartDate { get; set; }
            public int Id { get; set; }
            public string Name { get; set; }
            public string EndDate { get; set; }
            public string PercentDone { get; set; }
            public string Resource { get; set; }
            public List<BusinessObject> Children { get; set; }
        }
        #endregion
    }
}

